

function getData(feProperties){
  var elements;
  try {
    var data = doRequest(getUrl());
    elements = JSON.parse(data).elements;
  }
  catch(err) {
    elements = testData.elements;
  }

    var result = [];
  for(var i in elements){
    var feData = elements[i];
    var fe = {};
    //cut uuid befefore "-" and remove leading numbers as they cannot be used as variable names
    fe.model = feData.modelUUID.split(".").join("");
    fe.id = fe.model + removeLeadingNumbersFromVariableName(feData.uuid.substr(0,8));
    fe.name = feData.description;
    fe.value = feData.value;
    if(feProperties[fe.model]){
      for(var j in feProperties[fe.model]){
        var value = feData[feProperties[fe.model][j]];
        if(value){
          if(!fe.properties){
            fe.properties = {};
          }
          fe.properties[feProperties[fe.model][j]] = value;
        }
      }
    }
    result.push(fe);
  }
  return result;
}

function doRequest(url) {
  return $.ajax({
    type: "GET",
    url: url,
    async: false
  }).responseText;
}

function getUrl() {
  var customerid = getCustomerid();
  if(!customerid){
    var element = document.getElementById("customerid");
    if(element && element.value.length > 0) {
      customerid = element.value;
    } else {
      customerid = "01016036958";
    }
  }

  var host = getParameterByName("host");
  if(!(host && host.length > 0)){
    host = "dd-dev.internal.delfidata.no"
  }

  var url = "http://" + host + ":8080/dd_server_fe/rest/fe/ancestry/v4/std/poc/" + customerid + "/thick?situation=0&includeProperties=true&validate=true";
  var result = url;
  for(var type in feTypes){
    result += "&model=" + feTypes[type];
  }
  var element = document.getElementById("url");
  element.href = url;
  return result;
}

function removeLeadingNumbersFromVariableName(value){
  var i = 0;
  while(i < value.length){
    var char = value.charAt(i);
    if(isNotNumber(char)){
      return value.substring(i, value.length);
    }
    i++;
  }
}

function getCustomerid() {
  var url = window.location.href;
  var regex = new RegExp("[?&]" + "customerid" + "(=([^&#]*)|&|#|$)"),
    results = regex.exec(url);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, " "));
}


function getParameterByName(name) {
  var url = window.location.href;
  name = name.replace(/[\[\]]/g, "\\$&");
  var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
    results = regex.exec(url);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, " "));
}

var feTypes = ["INCOME.BUSINESS.NO",
  "INCOME.COMPANY.CAR",
  "SAVING.PORTFOLIO",
  "EXPENSES.AFTERSCHOOL",
  "COLLATERAL.OBJECT.SHIP",
  "INSURANCE.DEATHS.CAPITAL",
  "COLLATERAL.OBJECT.COOP.APARTMENT",
  "EXPENSES.MEDICINE.HEALTH.CARE",
  "EXPENSES.CHILD.CARE",
  "COLLATERAL.OBJECT.VEHICLE",
  "LOAN.INSTALLMENT.SURETY",
  "INCOME.PENSION",
  "INCOME.CAR.ALLOWANCE",
  "EXPENSES.FUND.SAVINGSAGREEMENT",
  "EXPENSES.TELEPHONE.MEDIA.LEISURE",
  "OTHERASSETS.OWNEDHOUSING",
  "FINANCE.FUND.ACCOUNT",
  "OTHERASSETS.BOAT",
  "FINANCE.ANNUITY",
  "PENSION.CONTRACTUAL",
  "OTHERASSETS.COOP.APARTMENT",
  "NULL",
  "EXPENSES.HOUSEHOLD",
  "COLLATERAL",
  "FINANSKAPITAL.DEPOTKONTO",
  "OTHERASSETS.BUILDING",
  "COLLATERAL.OBJECT",
  "OTHERASSETS.OTHERASSETS",
  "INSURANCE.DISABILITY.CAPITAL",
  "INCOME.OTHER",
  "INSURANCE.CRITICAL.ILLNESS",
  "EXPENSES.OTHER",
  "OTHERASSETS.SHIP",
  "LOAN.CREDIT",
  "INCOME.SALARY",
  "INCOME.CASHBENEFIT",
  "PENSION.PUBLIC.SERVICE",
  "INCOME.CHILDBENEFIT",
  "FINANSKAPITAL.BANKINNSKUDD",
  "INSURANCE.CHILD.AND.YOUTH.PENSION",
  "OTHERASSETS.VEHICLE",
  "INSURANCE.GROUP.LIFE",
  "INSURANCE.DISABILITY.ANNUITIES",
  "OTHERASSETS.SHAREDHOUSING.NO",
  "PENSION.NATIONAL.INSURANCE",
  "COLLATERAL.OBJECT.SHAREDHOUSING",
  "FINANSKAPITAL.ANNENKAPITAL",
  "LOAN.HOUSECREDIT",
  "LOAN.INSTALLMENT",
  "FINANSKAPITAL.VERDIPAPIR"];

